# Configuration file for the Sphinx documentation builder.
#
# This file only contains a selection of the most common options. For a full
# list see the documentation:
# https://www.sphinx-doc.org/en/master/usage/configuration.html


# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
import os

# import sys
# sys.path.insert(0, os.path.abspath('.'))

import sphinx_rtd_theme


# -- Project information -----------------------------------------------------

project = "GEM DAQ user's guide"
author = u"CMS GEM DAQ project"
copyright = "2020, {:s}".format(author)
## These are parsed once for all files in the make site target
# revision=os.popen("git describe --abbrev=8 --dirty --always").read().strip()
# lastupdate=os.popen("date -u +'%a %b %d %Y %T %Z'").read().strip()

# The full version, including alpha/beta/rc tags
release = "0.0.1"


# -- General configuration ---------------------------------------------------

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    "sphinx.ext.autodoc",
    "sphinx.ext.doctest",
    "sphinx.ext.todo",
    "sphinx.ext.coverage",
    "sphinx.ext.mathjax",
    "sphinx.ext.ifconfig",
    "sphinx.ext.viewcode",
    "sphinx.ext.intersphinx",
    "sphinx.ext.extlinks",
    "sphinxcontrib.srclinks",
    # "sphinxcontrib.osexample",
    "sphinx_copybutton",
    "sphinx_tabs.tabs",
    "sphinx_rtd_theme",
    "sphinx_bootstrap_theme",
    "guzzle_sphinx_theme",
]

# Tell sphinx what the primary language being documented is.
primary_domain = "cpp"

# Tell sphinx what the pygments highlight language should be.
highlight_language = "cpp"

# Add any paths that contain templates here, relative to this directory.
templates_path = ["_templates"]

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
#
# source_suffix = ['.rst', '.md']
source_suffix = ".rst"

# The master toctree document.
master_doc = "index"

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = None

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path.
exclude_patterns = []

# Links to other Documentation
intersphinx_mapping = {
    "devguide": (os.getenv("GEM_DOCS_URL") + "/guides/devguide", None,),
    "expertguide": (os.getenv("GEM_DOCS_URL") + "/guides/expertguide", None,),
    "cmsgemos": (os.getenv("EOS_SITE_URL") + "/docs/api/cmsgemos/latest", None,),
    "gemplotting": (os.getenv("EOS_SITE_URL") + "/docs/api/gemplotting/latest", None,),
    "vfatqc": (os.getenv("EOS_SITE_URL") + "/docs/api/vfatqc/latest", None,),
    "ctp7_modules": (
        os.getenv("EOS_SITE_URL") + "/docs/api/ctp7_modules/latest",
        None,
    ),
    "reg_utils": (os.getenv("EOS_SITE_URL") + "/docs/api/reg_utils/latest", None,),
    "xhal": (os.getenv("EOS_SITE_URL") + "/docs/api/xhal/latest", None,),
    "gemctp7user": (os.getenv("EOS_SITE_URL") + "/docs/api/gemctp7user/latest", None,),
}

srclink_project = "https://gitlab.cern.ch/sturdy/gemdocs"
srclink_branch = "master"
srclink_src_path = "/userguide/docs"

extlinks = {"baseurl": (os.getenv("GEM_DOCS_URL") + "%s", None)}

rst_prolog = """
.. role:: strike
   :class: strike
"""

rst_epilog = """
.. _gemdaq site: https://cmsgemonline.web.cern.ch/doc

.. _GEM DAQ Mattermost: https://mattermost.web.cern.ch/cms-gem-daq
.. _GEM Ops Mattermost: https://mattermost.web.cern.ch/cms-gem-ops

.. _VFAT3 site: https://espace.cern.ch/cms-project-GEMElectronics/VFAT3/Forms/AllItems.aspx
.. _FEAST project site: https://project-dcdc.web.cern.ch/project-dcdc
.. _FEASTMP datasheet: https://project-dcdc.web.cern.ch/project-dcdc/public/Documents/FEASTMod_Datasheet.pdf
.. _cmsons jira: https://its.cern.ch/jira/projects/CMSONS
.. _cmsos jira: https://its.cern.ch/jira/projects/CMSOS
.. _cluster twiki: https://twiki.cern.ch/twiki/bin/view/CMS/Net-and-Sys-admin-Users
.. _cluster users guide: https://twiki.cern.ch/twiki/bin/view/CMS/ClusterUsersGuide

.. |gemos-site-baseurl| replace:: {:s}
""".format(
    os.getenv("GEM_DOCS_URL")
)

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = "sphinx"

# If true, `todo` and `todoList` produce output, else they produce nothing.
todo_include_todos = True


# -- Options for HTML output -------------------------------------------------

html_context = {
    "display_gitlab": True,
    "gitlab_host": "gitlab.cern.ch",
    "gitlab_user": "sturdy",
    "gitlab_repo": "gemdocs",
    "gitlab_version": "master",
    "conf_py_path": "/userguide/docs/source/",
    "last_updated": "UPDATE_DATE",
    "commit": "GIT_REVISION"
}

# The name for this set of Sphinx documents.  If None, it defaults to
# "<project> v<release> documentation".
html_title = "GEM DAQ User's Guide"

# A shorter title for the navigation bar.  Default is the same as html_title.
html_short_title = "User's Guide"

## Set an image file to be used as a logo at the top of the sidebar
# html_logo

## Show only the logo at the top of the sidebar
# logo_only

## Use rtd theme
html_theme = "sphinx_rtd_theme"

html_theme_options = {
    "navigation_depth": 50,
}

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ["_static"]

# Custom CSS
# These paths are either relative to html_static_path
# or fully qualified paths (eg. https://...)
html_css_files = [
    "{}/css/rtd-custom.css".format(os.getenv("GEM_DOCS_URL")),
]

# Custom JavaScript
# These paths are either relative to html_static_path
# or fully qualified paths (eg. https://...)
html_js_files = [
    # enable for arrow key navigation
    # "{}/scripts/js/guides-navigation.js".format(os.getenv("GEM_DOCS_URL")),
]
